The error flash message on session expiration is not in the language of the user but of the user of
Target version: 2.6.0

Resolution: Fixed Affected version: 251
Description

One of our customers at Planio noticed that after an expired session, the notification message is displayed in a wrong language. The
i18n gem saves the current locale in Thread.current[:i18n_config], which on some app servers (i.e. most other than Webrick) is
preserved between requests. That means, if the current locale is not updated for each request, the one from the previous request will
be used.

Currently, the session_expiration before filter in ApplicationController does not set the locale, leading to the flash message with the
expiration message to be saved to the session in the language of the previous user.

The attached patch fixes this behaviour. It sets the language defined for the user_id of the session (if present) or the default
language.

This bug is probably not a grave security issue as no further information besides the language of the previous request is leaked.

Related issues:

Has duplicate Redmine - Defect #18747: Automatic log out error message is in ... Closed

Associated revisions

Revision 13391 - 2014-09-13 12:35 - Jean-Philippe Lang

Fixed: The error flash message on session expiration is not in the language of the user but of the user of the previous request (#17023).

History

#1 - 2014-05-28 17:20 - Jan from Planio www.plan.io
- Category changed from Text formatting to 118n

- Target version set to Candidate for next minor release

#2 - 2014-06-12 10:13 - Toshi MARUYAMA

- Target version changed from Candidate for next minor release to 2.6.0

#3 - 2014-08-20 22:27 - Etienne Massip
- Target version changed from 2.6.0 to 2.5.3

Since it's a simply fixed issue.

I'm not fond of the assignment inside the if test, though.

#4 - 2014-09-03 17:32 - Holger Just

Another option would be to move the session_expiration filter after the user_setup. That way, we would have a proper User.current set and could just
reuse the existing logic in set_localization. This could then look like this:

def session_expiration
if session[:user_id]
if session_expired? && !try_to_autologin
reset_session
set_localization
flash[:error] = 1l(:error_session_expired)
redirect_to signin_url
else
session[:atime] = Time.now.utc.to_i
end
end
end

#5 - 2014-09-03 22:17 - Etienne Massip

user_setup requires session, but why not simply call set_localization when session is expired?

#6 - 2014-09-05 13:28 - Holger Just

Because set_localization uses User.current to find the language selected in the user's preferences, however User.current is only set by user_setup.
As such, we can run set_localozation only after user_setup.

#7 - 2014-09-13 12:36 - Jean-Philippe Lang
- Status changed from New to Resolved
- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Fixed in r13391.

#8 - 2014-09-14 11:16 - Jean-Philippe Lang
- Status changed from Resolved to Closed

- Target version changed from 2.5.3 to 2.6.0

#9 - 2015-01-05 05:45 - Toshi MARUYAMA

- Has duplicate Defect #18747: Automatic log out error message is in another language. added

#10 - 2015-01-22 00:58 - Josh Miller

Removed to start a new ticket, sorry for the noise.

Files

0001-Set-118n-language-on-the-request-even-if-the-session.patch 1.03 KB 2014-05-28 Holger Just

2025-05-02 22


https://www.redmine.org/projects/redmine/repository/svn/revisions/13391
http://www.tcpdf.org

